
#ifdef V4L2
#include "v4l2_capture.h"
#endif

#define MAXCONN 100
#define MAX_USER_THREADS 4 
#define DEFAULT_PORT 5555
#define GC_TIME 30 
#define PASS64_LEN 512
#define DEFAULT_JPEG_QUALITY 80

#define VIDEO_NUM_404 404
#define VIDEO_NUM_400 400
#define BIGGEST_SUPPORTED_FILE 400000
#define BIGGEST_FILE_CHUNK 1024
#define CHUNKS_PER_SEND 8
#define STATE_IDLE 0
#define STATE_HEADERS 1
#define STATE_SEND_FILE 2
#define NEED_HEADER_NO 0
#define NEED_HEADER_YES 1
#define REQUEST_SINGLE 0
#define REQUEST_MULTIPART 1
#define REQUEST_MULTIPART2 2

#ifdef WINDOWS
#define SHUT_RDWR SD_BOTH
#include <winsock2.h>
/* int gettimeofday(struct timeval *tv, struct timezone *tz); */
int gettimeofday(struct timeval *tv, int tz);
#endif

/* YOU MAY NOT EDIT THIS NEXT TWO LINES OF CODE */
#define VERSION "Naken Web - February 28, 2007 - alpha"
#define COPYRIGHT "Copyright 2004-2007 Michael Kohn"
/* THIS IS NOT GPL */

#define FOUR_OH_FOUR "<html><body><br><br><h1>404 - Naken Web FILE NOT FOUND</h1></body></html>\r\n"
#define FOUR_OH_ONE "<html><body><br><br><h1>401 - Naken Web Authorization Required</h1></body></html>\r\n"
#define VIDEO_ERROR "<html><body><br><br><h1>Naken Web Error: AVI frame too big or parse error</h1></body></html>\r\n"
#ifdef ENABLE_CGI
#define FOUR_OH_OH "<html><body><br><br><h1>400 - Naken Web Bad Request</h1></body></html>\r\n"
#endif

struct User
{
  unsigned char location[64];
  char outString[514];
  unsigned char myString[514];
  int ID,r;
  int logontime,idletime;
  char inuse;
  int socketid;
  int sptr,slen;
  int buffer_ptr;
  int curr_frame;
  FILE *in,*socketfd;
#ifdef WITH_MMAP
  long offset;
#endif
  int video_num;
  int mime_type;
  long content_length;
  time_t last_modified;
  int state;
  int need_header;
  int request_type;
  int last_frame;
  unsigned int flags;
  int frame_rate;
#ifdef V4L2
  unsigned char *jpeg;
  int jpeg_len;
  int jpeg_quality;
  int jpeg_ptr;
#endif
};

// FIXME - a linked list here could save memory
struct video_t
{
  char *filename;
  long *index;
  int fps;
  int total_frames;
  struct timeval tv_start;
  struct timeval tv_total;
#ifdef V4L2
  struct capture_info_t *capture_info;
#endif
#ifdef WITH_MMAP
  long file_len;
  unsigned char *mem;
#ifndef WINDOWS
  int fd;
#else
  HANDLE fd;
  HANDLE mem_handle;
#endif
#endif
};

struct alias_t
{
  struct alias_t *next_alias;
  int port;
  int port_start;
  int type;
  int url_len;
  char *url;
  char *port_param;
  char *size_param;
  char *comp_param;
  char *fps_param;
};

#ifdef ENABLE_CGI
struct cgi_handler_t
{
  struct cgi_handler_t *next_handler;
  char *extension;
  char *application;
};
#endif

/* TODO -- Kill these global variables */
extern int sockfd,port;
extern char *runas_user;
extern char *runas_group;
extern int video_count;
extern struct User **users;
extern struct video_t video[100];
extern int debug;
extern unsigned int uptime;
extern unsigned short int serverflags;
/* extern char *config_dir; */
extern char *htdocs_dir;
extern int maxconn;
extern int minconn;
extern int max_idle_time;
extern char user_pass_64[PASS64_LEN];
extern int jpeg_quality;
extern struct alias_t *alias; 
#ifdef ENABLE_CGI
extern struct cgi_handler_t *cgi_handler; 
#endif
extern int frame_rate;
extern const char *mime_types[];
extern const char *extensions[];
extern const int mime_type_code[];

/*

User Flags

0: authentication okay
1: did authenication once

*/

